From: Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>
Date: Wed, 23 Mar 2022 00:46:01 +0100
Subject: power: supply: bq25890_charger: Don't report bogus temperature
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 8bit

Report a lack of reading instead of trying to interpret it as a
temperature. Fixes bogus 85°C readings when the battery is under voltage
regulation.
---
 drivers/power/supply/bq25890_charger.c | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/drivers/power/supply/bq25890_charger.c b/drivers/power/supply/bq25890_charger.c
index cd4bb10..74669d8 100644
--- a/drivers/power/supply/bq25890_charger.c
+++ b/drivers/power/supply/bq25890_charger.c
@@ -591,6 +591,8 @@ static int bq25890_power_supply_get_property(struct power_supply *psy,
 		ret = bq25890_field_read(bq, F_TSPCT);
 		if (ret < 0)
 			return ret;
+		if (ret == 0)
+			return -ENODATA;
 
 		/* convert TS percentage into rough temperature */
 		val->intval = bq25890_find_val(ret, TBL_TSPCT);
